unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Buttons, ExtCtrls, Grids, DBGrids, StdCtrls, EXLReport;

type
  TForm1 = class(TForm)
    ExamplesTree: TTreeView;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Panel2: TPanel;
    TemplateButton: TSpeedButton;
    ReportButton: TSpeedButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    CommentMemo: TMemo;
    DetailGrid: TDBGrid;
    Splitter2: TSplitter;
    MasterGrid: TDBGrid;
    PropertiesMemo: TMemo;
    CodeMemo: TMemo;
    Timer1: TTimer;
    Panel3: TPanel;
    procedure Timer1Timer(Sender: TObject);
    procedure ExamplesTreeChange(Sender: TObject; Node: TTreeNode);
    procedure TemplateButtonClick(Sender: TObject);
    procedure ReportButtonClick(Sender: TObject);
  private
    { Private declarations }
    FXLRComponent: TEXLReport;
    FDetailGridHeight: Integer;
    procedure UpdateForm;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Reports;

{$R *.dfm}

procedure TForm1.UpdateForm;
begin
  FXLRComponent := nil;
  if ExamplesTree.Selected.Level = 0 then
  begin
    if Assigned(ReportContainer) then
    begin
      DetailGrid.DataSource.DataSet.Close;
      MasterGrid.DataSource.DataSet.Close;
    end;
    CommentMemo.Clear;
    PropertiesMemo.Clear;
    CodeMemo.Clear;
  end
  else begin
    CommentMemo.Lines.BeginUpdate;
    PropertiesMemo.Lines.BeginUpdate;
    CodeMemo.Lines.BeginUpdate;
    try
      FXLRComponent := ReportContainer.LoadReportData(ExamplesTree.Selected.Text,
                       CommentMemo.Lines, PropertiesMemo.Lines, CodeMemo.Lines);
    finally
      CommentMemo.SelStart := 0;
      CommentMemo.Lines.EndUpdate;
      PropertiesMemo.SelStart := 0;
      PropertiesMemo.Lines.EndUpdate;
      CodeMemo.SelStart := 0;
      CodeMemo.Lines.EndUpdate;
    end;
    if DetailGrid.DataSource.DataSet.Active then
    begin
      if DetailGrid.Height = 0 then DetailGrid.Height := FDetailGridHeight;
    end
    else
      if DetailGrid.Height <> 0 then
      begin
        FDetailGridHeight := DetailGrid.Height;
        DetailGrid.Height := 0;
      end;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  UpdateForm;
end;

procedure TForm1.ExamplesTreeChange(Sender: TObject; Node: TTreeNode);
begin
  Timer1.Enabled := True;
end;

procedure TForm1.TemplateButtonClick(Sender: TObject);
begin
  if Assigned(FXLRComponent) then FXLRComponent.EditTemplate;
end;

procedure TForm1.ReportButtonClick(Sender: TObject);
begin
  if Assigned(FXLRComponent) then FXLRComponent.Show;
end;

end.
